(define (domain openstacks-sequencedstrips-nonadl-nonnegated)
  (:requirements :typing :action-costs)
  (:types
          order - object
          product - object
          count - object
  )
  (:predicates
          (includes ?o - order ?p - product)
          (waiting ?o - order)
          (started ?o - order)
          (shipped ?o - order)
          (made ?p - product)
          (not-made ?p - product)
          (stacks-avail ?s - count)
          (next-count ?s - count ?ns - count)
          (is_constant_p1 ?x - product)
          (is_constant_p2 ?x - product)
          (is_constant_p3 ?x - product)
          (is_constant_p4 ?x - product)
          (is_constant_p5 ?x - product)
          (is_constant_p6 ?x - product)
          (is_constant_p7 ?x - product)
          (is_constant_p8 ?x - product)
          (is_constant_p9 ?x - product)
          (is_constant_p10 ?x - product)
          (is_constant_o1 ?x - order)
          (is_constant_o2 ?x - order)
          (is_constant_o3 ?x - order)
          (is_constant_o4 ?x - order)
          (is_constant_o5 ?x - order)
          (is_constant_o6 ?x - order)
          (is_constant_o7 ?x - order)
          (is_constant_o8 ?x - order)
          (is_constant_o9 ?x - order)
          (is_constant_o10 ?x - order)
          )
  (:functions
          (total-cost ) - number
          )
  (:action open-new-stack
          :parameters (
               ?open - count
               ?new-open - count
               )
          :precondition
               (and
                    (stacks-avail ?open)
                    (next-count ?open ?new-open)
               )
          :effect
               (and
                    (not (stacks-avail ?open))
                    (stacks-avail ?new-open)
                    (increase (total-cost) 1)
               )
  )
  (:action start-order
          :parameters (
               ?o - order
               ?avail - count
               ?new-avail - count
               )
          :precondition
               (and
                    (waiting ?o)
                    (stacks-avail ?avail)
                    (next-count ?new-avail ?avail)
               )
          :effect
               (and
                    (not (waiting ?o))
                    (started ?o)
                    (not (stacks-avail ?avail))
                    (stacks-avail ?new-avail)
               )
  )
  (:action make-product-p1
          :parameters (
               ?const0 - product
               ?const1 - order
               ?const2 - order
               )
          :precondition
               (and
                    (not-made ?const0)
                    (started ?const1)
                    (started ?const2)
                    (is_constant_p1 ?const0)
                    (is_constant_o3 ?const1)
                    (is_constant_o9 ?const2)
               )
          :effect
               (and
                    (not (not-made ?const0))
                    (made ?const0)
               )
  )
  (:action make-product-p2
          :parameters (
               ?const0 - product
               ?const1 - order
               )
          :precondition
               (and
                    (not-made ?const0)
                    (started ?const1)
                    (is_constant_p2 ?const0)
                    (is_constant_o2 ?const1)
               )
          :effect
               (and
                    (not (not-made ?const0))
                    (made ?const0)
               )
  )
  (:action make-product-p3
          :parameters (
               ?const0 - product
               ?const1 - order
               ?const2 - order
               )
          :precondition
               (and
                    (not-made ?const0)
                    (started ?const1)
                    (started ?const2)
                    (is_constant_p3 ?const0)
                    (is_constant_o5 ?const1)
                    (is_constant_o8 ?const2)
               )
          :effect
               (and
                    (not (not-made ?const0))
                    (made ?const0)
               )
  )
  (:action make-product-p4
          :parameters (
               ?const0 - order
               ?const1 - product
               )
          :precondition
               (and
                    (not-made ?const1)
                    (started ?const0)
                    (is_constant_o4 ?const0)
                    (is_constant_p4 ?const1)
               )
          :effect
               (and
                    (not (not-made ?const1))
                    (made ?const1)
               )
  )
  (:action make-product-p5
          :parameters (
               ?const0 - order
               ?const1 - order
               ?const2 - product
               )
          :precondition
               (and
                    (not-made ?const2)
                    (started ?const1)
                    (started ?const0)
                    (is_constant_o7 ?const0)
                    (is_constant_o6 ?const1)
                    (is_constant_p5 ?const2)
               )
          :effect
               (and
                    (not (not-made ?const2))
                    (made ?const2)
               )
  )
  (:action make-product-p6
          :parameters (
               ?const0 - product
               ?const1 - order
               )
          :precondition
               (and
                    (not-made ?const0)
                    (started ?const1)
                    (is_constant_p6 ?const0)
                    (is_constant_o1 ?const1)
               )
          :effect
               (and
                    (not (not-made ?const0))
                    (made ?const0)
               )
  )
  (:action make-product-p7
          :parameters (
               ?const0 - order
               ?const1 - product
               )
          :precondition
               (and
                    (not-made ?const1)
                    (started ?const0)
                    (is_constant_o3 ?const0)
                    (is_constant_p7 ?const1)
               )
          :effect
               (and
                    (not (not-made ?const1))
                    (made ?const1)
               )
  )
  (:action make-product-p8
          :parameters (
               ?const0 - product
               ?const1 - order
               )
          :precondition
               (and
                    (not-made ?const0)
                    (started ?const1)
                    (is_constant_p8 ?const0)
                    (is_constant_o3 ?const1)
               )
          :effect
               (and
                    (not (not-made ?const0))
                    (made ?const0)
               )
  )
  (:action make-product-p9
          :parameters (
               ?const0 - product
               ?const1 - order
               ?const2 - order
               )
          :precondition
               (and
                    (not-made ?const0)
                    (started ?const1)
                    (started ?const2)
                    (is_constant_p9 ?const0)
                    (is_constant_o1 ?const1)
                    (is_constant_o10 ?const2)
               )
          :effect
               (and
                    (not (not-made ?const0))
                    (made ?const0)
               )
  )
  (:action make-product-p10
          :parameters (
               ?const0 - product
               ?const1 - order
               ?const2 - order
               )
          :precondition
               (and
                    (not-made ?const0)
                    (started ?const2)
                    (started ?const1)
                    (is_constant_p10 ?const0)
                    (is_constant_o2 ?const1)
                    (is_constant_o1 ?const2)
               )
          :effect
               (and
                    (not (not-made ?const0))
                    (made ?const0)
               )
  )
  (:action ship-order-o1
          :parameters (
               ?avail - count
               ?new-avail - count
               ?const0 - product
               ?const1 - product
               ?const2 - product
               ?const3 - order
               )
          :precondition
               (and
                    (started ?const3)
                    (made ?const2)
                    (made ?const1)
                    (made ?const0)
                    (stacks-avail ?avail)
                    (next-count ?avail ?new-avail)
                    (is_constant_p10 ?const0)
                    (is_constant_p9 ?const1)
                    (is_constant_p6 ?const2)
                    (is_constant_o1 ?const3)
               )
          :effect
               (and
                    (not (started ?const3))
                    (shipped ?const3)
                    (not (stacks-avail ?avail))
                    (stacks-avail ?new-avail)
               )
  )
  (:action ship-order-o2
          :parameters (
               ?avail - count
               ?new-avail - count
               ?const0 - product
               ?const1 - product
               ?const2 - order
               )
          :precondition
               (and
                    (started ?const2)
                    (made ?const0)
                    (made ?const1)
                    (stacks-avail ?avail)
                    (next-count ?avail ?new-avail)
                    (is_constant_p2 ?const0)
                    (is_constant_p10 ?const1)
                    (is_constant_o2 ?const2)
               )
          :effect
               (and
                    (not (started ?const2))
                    (shipped ?const2)
                    (not (stacks-avail ?avail))
                    (stacks-avail ?new-avail)
               )
  )
  (:action ship-order-o3
          :parameters (
               ?avail - count
               ?new-avail - count
               ?const0 - product
               ?const1 - product
               ?const2 - order
               ?const3 - product
               )
          :precondition
               (and
                    (started ?const2)
                    (made ?const1)
                    (made ?const3)
                    (made ?const0)
                    (stacks-avail ?avail)
                    (next-count ?avail ?new-avail)
                    (is_constant_p8 ?const0)
                    (is_constant_p1 ?const1)
                    (is_constant_o3 ?const2)
                    (is_constant_p7 ?const3)
               )
          :effect
               (and
                    (not (started ?const2))
                    (shipped ?const2)
                    (not (stacks-avail ?avail))
                    (stacks-avail ?new-avail)
               )
  )
  (:action ship-order-o4
          :parameters (
               ?avail - count
               ?new-avail - count
               ?const0 - order
               ?const1 - product
               )
          :precondition
               (and
                    (started ?const0)
                    (made ?const1)
                    (stacks-avail ?avail)
                    (next-count ?avail ?new-avail)
                    (is_constant_o4 ?const0)
                    (is_constant_p4 ?const1)
               )
          :effect
               (and
                    (not (started ?const0))
                    (shipped ?const0)
                    (not (stacks-avail ?avail))
                    (stacks-avail ?new-avail)
               )
  )
  (:action ship-order-o5
          :parameters (
               ?avail - count
               ?new-avail - count
               ?const0 - product
               ?const1 - order
               )
          :precondition
               (and
                    (started ?const1)
                    (made ?const0)
                    (stacks-avail ?avail)
                    (next-count ?avail ?new-avail)
                    (is_constant_p3 ?const0)
                    (is_constant_o5 ?const1)
               )
          :effect
               (and
                    (not (started ?const1))
                    (shipped ?const1)
                    (not (stacks-avail ?avail))
                    (stacks-avail ?new-avail)
               )
  )
  (:action ship-order-o6
          :parameters (
               ?avail - count
               ?new-avail - count
               ?const0 - order
               ?const1 - product
               )
          :precondition
               (and
                    (started ?const0)
                    (made ?const1)
                    (stacks-avail ?avail)
                    (next-count ?avail ?new-avail)
                    (is_constant_o6 ?const0)
                    (is_constant_p5 ?const1)
               )
          :effect
               (and
                    (not (started ?const0))
                    (shipped ?const0)
                    (not (stacks-avail ?avail))
                    (stacks-avail ?new-avail)
               )
  )
  (:action ship-order-o7
          :parameters (
               ?avail - count
               ?new-avail - count
               ?const0 - order
               ?const1 - product
               )
          :precondition
               (and
                    (started ?const0)
                    (made ?const1)
                    (stacks-avail ?avail)
                    (next-count ?avail ?new-avail)
                    (is_constant_o7 ?const0)
                    (is_constant_p5 ?const1)
               )
          :effect
               (and
                    (not (started ?const0))
                    (shipped ?const0)
                    (not (stacks-avail ?avail))
                    (stacks-avail ?new-avail)
               )
  )
  (:action ship-order-o8
          :parameters (
               ?avail - count
               ?new-avail - count
               ?const0 - product
               ?const1 - order
               )
          :precondition
               (and
                    (started ?const1)
                    (made ?const0)
                    (stacks-avail ?avail)
                    (next-count ?avail ?new-avail)
                    (is_constant_p3 ?const0)
                    (is_constant_o8 ?const1)
               )
          :effect
               (and
                    (not (started ?const1))
                    (shipped ?const1)
                    (not (stacks-avail ?avail))
                    (stacks-avail ?new-avail)
               )
  )
  (:action ship-order-o9
          :parameters (
               ?avail - count
               ?new-avail - count
               ?const0 - product
               ?const1 - order
               )
          :precondition
               (and
                    (started ?const1)
                    (made ?const0)
                    (stacks-avail ?avail)
                    (next-count ?avail ?new-avail)
                    (is_constant_p1 ?const0)
                    (is_constant_o9 ?const1)
               )
          :effect
               (and
                    (not (started ?const1))
                    (shipped ?const1)
                    (not (stacks-avail ?avail))
                    (stacks-avail ?new-avail)
               )
  )
  (:action ship-order-o10
          :parameters (
               ?avail - count
               ?new-avail - count
               ?const0 - product
               ?const1 - order
               )
          :precondition
               (and
                    (started ?const1)
                    (made ?const0)
                    (stacks-avail ?avail)
                    (next-count ?avail ?new-avail)
                    (is_constant_p9 ?const0)
                    (is_constant_o10 ?const1)
               )
          :effect
               (and
                    (not (started ?const1))
                    (shipped ?const1)
                    (not (stacks-avail ?avail))
                    (stacks-avail ?new-avail)
               )
  )
)
